--
-- automaticMilkSale
--
-- @author  nilBrain
-- @date 	24.06.2022
-- @node	This Script do sold atomaticly Milk from Husbandry.
-- @update	Call "EconomyManager" from the Instance not from the Class, add debug func, call Animals over Method...
--			V 1.1.0.0 add more fillType support

automaticMilkSale = {};

automaticMilkSale.FILLTYPES_TO_HUSBANDRY = {
	["COW"] = {"MILK"},
	["HAYCOW"] = {"HAYMILK"},
	["GOAT"] = {"GOATMILK"},
	["SHEEP"] = {"SHEEPMILK"}
};

function automaticMilkSale:loadMap(mapFilename)
	if g_currentMission:getIsServer() then
		g_messageCenter:subscribe(MessageType.HOUR_CHANGED, self.hourChanged, self);
	end;
end;

function automaticMilkSale:deleteMap()
	if g_currentMission:getIsServer() then
		g_messageCenter:unsubscribe(MessageType.HOUR_CHANGED, self);
	end;
end;

function automaticMilkSale:sellMilk()
	for _, placeable in ipairs(g_currentMission.husbandrySystem.placeables) do
		for hType, fillTypes in pairs(automaticMilkSale.FILLTYPES_TO_HUSBANDRY) do
			if placeable:getAnimalTypeIndex() == AnimalType[hType] then
				if placeable:getOwnerFarmId() ~= FarmManager.SPECTATOR_FARM_ID then
					if placeable:getNumOfAnimals() > 0 then
						for _, fillType in ipairs(fillTypes) do
							local fillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(fillType);
							if fillTypeIndex ~= nil then
								local fillLevel = placeable:getHusbandryFillLevel(fillTypeIndex);
								placeable:removeHusbandryFillLevel(nil, fillLevel, fillTypeIndex);
								local price = fillLevel * g_currentMission.economyManager:getPricePerLiter(fillTypeIndex);
								g_currentMission:addMoney(price, placeable:getOwnerFarmId(), MoneyType.SOLD_MILK, true, true);
							end;
						end;
					end;
				end;
			end;
		end;
	end;
	return 0;
end;

function automaticMilkSale:hourChanged()
	local currentHour = g_currentMission.environment.currentHour

	if currentHour == 6 then
		self:sellMilk();
	end;
end;

addModEventListener(automaticMilkSale);